<?php
session_start();
 
/**
 * URL API
 */
define('API_URL_PROD', 'https://engine.paymentgate.ru/payment/rest/'); // Продакшн/Бой
define('API_URL_TEST', 'https://web.rbsuat.com/ab/rest/'); // Тест


/**
 * Режим теста
 */
define('TEST_MODE', true);


/**
 * Версия плагина
 */
define(VERSION, '1.0.0');
define(VERSION_DATE, '2015-01-26 14:00:00');

/**
 * Плагин
 */
if(TEST_MODE) {error_reporting(E_ALL & ~E_NOTICE);}

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVMPaymentRBS_Payment extends vmPSPlugin
{
	public static $_this = false;
	public static $flag = false;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}

    protected function getVmPluginCreateTableSQL() {return $this->createTableSQL('Payment RBS Table');}
    
    function getTableSQLFields()
    {
		$SQLfields = array(
	    	'id'							=> 'int(11) unsigned NOT NULL AUTO_INCREMENT',
	    	'virtuemart_order_number'		=> 'char(32) DEFAULT NULL',
	    	'virtuemart_order_id'			=> 'char(32) DEFAULT NULL',
	    	'virtuemart_paymentmethod_id'	=> 'char(32) DEFAULT NULL',
	    	'rbs_order_id'					=> 'char(36) DEFAULT NULL'
		);
		return $SQLfields;
    }
    
    function plgVmConfirmedOrder($cart, $order) 
    {
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {return null;}
		if (!$this->selectedThisElement($method->payment_element)) {return false;}

		$session = JFactory::getSession();
		$return_context = $session->getId();

		if (!class_exists('VirtueMartModelOrders')) {require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
	    if (!class_exists('VirtueMartModelCurrency')){require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');}

		$args = Array(
			'userName'		=> $method->merchant,
			'password'		=> $method->password,
			'amount'		=> round($order['details']['BT']->order_total * 100),
			'orderNumber'	=> $order['details']['BT']->order_number, 
			'returnUrl'		=> JURI::root().'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&method=payment'
		);
		
		if($method->test == '1') {$action_adr = API_URL_TEST;}
		else {$action_adr = API_URL_PROD;}
		if($method->step == '1') {$action_adr .= 'register.do';}
		else {$action_adr .= 'registerPreAuth.do';}
		$_SESSION['test'] = $method->test;
		
		$rbsCurl = curl_init();
		curl_setopt_array($rbsCurl, array(
		    CURLOPT_URL => $action_adr,
		    CURLOPT_RETURNTRANSFER => true,
		    CURLOPT_POST => true,
		    CURLOPT_POSTFIELDS => http_build_query($args)
		));
		$response = curl_exec($rbsCurl);
		curl_close($rbsCurl);
		$response = json_decode($response, true);
		if(TEST_MODE) {$this->logInfo($action_adr, json_encode($args), json_encode($response));}

		$errorCode = $response['errorCode'];
		if ($errorCode == 0) {
			$dbValues = array();
			$dbValues['virtuemart_paymentmethod_id']	= $order['details']['BT']->virtuemart_paymentmethod_id;
			$dbValues['virtuemart_order_number']		= $order['details']['BT']->order_number;
			$dbValues['virtuemart_order_id']			= $order['details']['BT']->virtuemart_order_id;
			$dbValues['rbs_order_id']					= $response['orderId'];
			$this->storePSPluginInternalData($dbValues);
			$html .= 'Пожалуйста, нажмите кнопку ниже, чтобы заплатить.<br>';
			$html .= '<a class="button cancel" href="'.$response['formUrl'].'">Оплатить</a>';
			$_SESSION['merchant'] = $method->merchant;
			$_SESSION['password'] = $method->password;
		}
		else {$html .= 'Ошибка #'.$errorCode.': '.$response['errorMessage'];}
		
		$this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $method->payment_name);
		return null;
    } 

	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {return null;}
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject()))
		{
	    	vmWarn(500, $q . " " . $db->getErrorMsg());
	    	return '';
		}
		$this->getPaymentCurrency($paymentTable);
		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('VMPAYMENT_RBS_PAYMENT', $paymentTable->payment_name);
		$html .= '</table>' . "\n";
		return $html;
    }

	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match ('/%$/', $method->cost_percent_total)) {$cost_percent_total = substr ($method->cost_percent_total, 0, -1);}
		else {$cost_percent_total = $method->cost_percent_total;}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}

    protected function checkConditions($cart, $method, $cart_prices) {return true;}
 
    function plgVmOnPaymentResponseReceived(&$html)
    {
		if(JRequest::getVar('method','')!='payment') {return NULL;}
		if(self::$flag) return null;
		$jlang = JFactory::getLanguage();
		$jlang->load ('plg_vmpayment_rbs_payment', JPATH_ADMINISTRATOR);
		$payment_data = JRequest::get('get');
		
		vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
		if (!class_exists('VirtueMartModelOrders')) {require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
		
		$rbs_order_id = $payment_data['orderId'];
		$q = 'SELECT `virtuemart_order_id` FROM `' . $this->_tablename . '` WHERE `rbs_order_id`="' . $rbs_order_id . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$virtuemart_order_id = $db->loadResult();
		$args = Array(
			'userName'		=> $_SESSION['merchant'],
			'password'		=> $_SESSION['password'],
			'orderId'		=> $rbs_order_id
		);
		
		if($_SESSION['test'] == '1') {$action_adr = API_URL_TEST;}
		else {$action_adr = API_URL_PROD;}
		$action_adr .= 'getOrderStatus.do';
		
		$_SESSION['merchant'] = '';
		$_SESSION['password'] = '';
		$_SESSION['test'] = '';
		
		$rbsCurl = curl_init();
		curl_setopt_array($rbsCurl, array(
		    CURLOPT_URL => $action_adr,
		    CURLOPT_RETURNTRANSFER => true,
		    CURLOPT_POST => true,
		    CURLOPT_POSTFIELDS => http_build_query($args)
		));
		$response = curl_exec($rbsCurl);
		curl_close($rbsCurl);
		$response = json_decode($response, true);
		if(TEST_MODE) {$this->logInfo($action_adr, json_encode($args), json_encode($response));}
		
		$orderStatus = $response['OrderStatus'];
		if ($orderStatus == '1' || $orderStatus == '2') 
		{
			$html .= 'Заказ успешно оплачен.';
			$modelOrder = VmModel::getModel('orders');
			$order = array();
			$order['order_status'] = "C";
			$order['comments']='RBSPayment '.$rbs_order_id;
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
			
			if (!class_exists('VirtueMartCart')) {require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');}
			$cart = VirtueMartCart::getCart();
			if (!class_exists('VirtueMartModelOrders')) {require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}

			$cart->emptyCart();
			self::$flag = true;
			return true;
		}
		else 
		{
			$modelOrder = VmModel::getModel('orders');
			$order = array();
			$order['order_status'] = "X";
			$order['comments']='RBSPayment '.$rbs_order_id;
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
			$html .= 'При оплате произошла ошибка. Попробуйте <a href="'.JURI::root().'index.php?option=com_virtuemart&view=cart">еще раз</a>.';
		}
		return null;
    }

	function plgVmOnUserPaymentCancel() {return null;}
    
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {return $this->onStoreInstallPluginTable($jplugin_id);}
    
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {return $this->OnSelectCheck($cart);}
    
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		$this->cart = $cart;
		return $this->displayListFE($cart, $selected, $htmlIn);
    }
	
    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);}
    
    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {return null;}
		if (!$this->selectedThisElement($method->payment_element)) {return false;}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
    }
    
    function logingActions($params)
    {
    	jimport('joomla.error.log');
    	$options = array('format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}");
    	$log = &JLog::getInstance('payment_events.log.php', $options);
    	$log->addEntry(array('ORDER' => $params['ORDER'],'ACTION' => $params['ACTION']));
    }
    
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {return $this->onCheckAutomaticSelected($cart, $cart_prices);}
    
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);}
    
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {return $this->onShowOrderPrint($order_number, $method_id);}

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {return $this->declarePluginParams('payment', $name, $id, $data);}

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {return $this->setOnTablePluginParams($name, $id, $table);}
	
	function logInfo ($action, $request, $response) {
		$file = JPATH_ROOT . "/logs/rbs_payment.log";
		$date = JFactory::getDate ();
		$fp = fopen ($file, 'a');
		fwrite ($fp, "\n" . $date->Format ('%Y-%m-%d %H:%M:%S') . " " . $action . "\nrequest: " . $request . "\nresponse: " . $response);
		fclose ($fp);
	}
}